<div class="page">
<?php
if ($this->HasAccess("read"))
{
	if (!$this->page)
	{
		print("This page doesn't exist yet. Maybe you want to <a href=\"".$this->href("edit")."\">create</a> it?");
	}
	else
	{
		// comment header?
		if ($this->page["comment_on"])
		{
			print("<div class=\"commentinfo\">This is a comment on ".$this->Link($this->page["comment_on"], "", "", 0).", posted by ".$this->Format($this->page["user"])." at ".$this->page["time"]."</div>");
		}

		if ($this->page["latest"] == "N")
		{
			print("<div class=\"revisioninfo\">This is an old revision of <a href=\"".$this->href()."\">".$this->GetPageTag()."</a> from ".$this->page["time"].".</div>");
		}


		// display page
		print($this->Format($this->page["body"], "wakka"));

		// if this is an old revision, display some buttons
		if ($this->HasAccess("write") && ($this->page["latest"] == "N"))
		{
			$latest = $this->LoadPage($this->tag);
			?>
			<br />
			<?php echo $this->FormOpen("edit") ?>
			<input type="hidden" name="previous" value="<?php echo $latest["id"] ?>" />
			<input type="hidden" name="body" value="<?php echo htmlentities($this->page["body"]) ?>" />
			<input type="submit" value="Re-edit this old revision" />
			<?php echo $this->FormClose(); ?>
			<?php
		}
	}
}
else
{
	print("<em>You aren't allowed to read this page.</em>");
}
?>
</div>


<?php
if ($this->HasAccess("read") && $this->GetConfigValue("hide_comments") != 1)
{
	// load comments for this page
	$comments = $this->LoadComments($this->tag);
	
	// store comments display in session
	$tag = $this->GetPageTag();
	if (!isset($_SESSION["show_comments"][$tag]))
		$_SESSION["show_comments"][$tag] = ($this->UserWantsComments() ? "1" : "0");
		
	switch($_REQUEST["show_comments"])
	{
	case "0":
		$_SESSION["show_comments"][$tag] = 0;
		break;
	case "1":
		$_SESSION["show_comments"][$tag] = 1;
		break;
	}
	
	// display comments!
	if ($this->page && $_SESSION["show_comments"][$tag])
	{
		// display comments header
		?>
		<a name="comments"></a>
		<div class="commentsheader">
			Comments [<a href="<?php echo $this->href("", "", "show_comments=0") ?>">Hide comments/form</a>]
		</div>
		<?php
		
		// display comments themselves
		if ($comments)
		{
			foreach ($comments as $comment)
			{
				print("<a name=\"".$comment["tag"]."\"></a>\n");
				print("<div class=\"comment\">\n");
				print($this->Format($comment["body"])."\n");
				print("<div class=\"commentinfo\">\n-- ".$this->Format($comment["user"])." (".$comment["time"].")\n</div>\n");
				print("</div>\n");
			}
		}
		
		// display comment form
		print("<div class=\"commentform\">\n");
		if ($this->HasAccess("comment"))
		{
			?>
				Attach a comment to this page:<br />
				<?php echo $this->FormOpen("addcomment"); ?>
					<textarea name="body" rows="6" style="width: 100%"></textarea><br />
					<input type="submit" value="Attach Comment" accesskey="s" />
				<?php echo $this->FormClose(); ?>
			<?php
		}
		print("</div>\n");
	}
	else
	{
		?>
		<div class="commentsheader">
		<?php
			switch (count($comments))
			{
			case 0:
				print("There is no comment on this page.");
				break;
			case 1:
				print("There is one comment on this page.");
				break;
			default:
				print("There are ".count($comments)." comments on this page.");
			}
		?>
		
		[<a href="<?php echo $this->href("", "", "show_comments=1#comments") ?>">Display comments/form</a>]

		</div>
		<?php
	}
}
?>